#ifndef TRC_MTQUEUE_H
#define TRC_MTQUEUE_H

#ifndef TRC_SEMAPHORE_H
#include "Semaphore.h"
#endif

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers = 32>
class TCMtQueue
{
public:
  TCMtQueue();
  ~TCMtQueue();

  T& Add1();
  void Add2();

  T& Delete1();
  void Delete2();

  bool IsEmpty();

private:
  T Buffers[NumBuffers];
  unsigned Head, Tail;

  bool Empty;

  TCSemaphore* pItems;
  TCSemaphore* pSpaces;
};
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
TCMtQueue<T, NumBuffers>::TCMtQueue()
{
  Head = 0;
  Tail = 0;
  Empty = true;
  pItems = new TCSemaphore(0);
  pSpaces = new TCSemaphore(NumBuffers-1);
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
TCMtQueue<T, NumBuffers>::~TCMtQueue()
{
  delete pItems;
  delete pSpaces;
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
T& TCMtQueue<T, NumBuffers>::Add1()
{
  pSpaces->Wait();
  return Buffers[Tail];
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
void TCMtQueue<T, NumBuffers>::Add2()
{
  ++Tail;
  if(Tail == NumBuffers) Tail = 0;
  Empty = false;

  pItems->Signal();
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
T& TCMtQueue<T, NumBuffers>::Delete1()
{
  pItems->Wait();
  return Buffers[Head];
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
void TCMtQueue<T, NumBuffers>::Delete2()
{
  ++Head;
  if (Head == NumBuffers) Head = 0;
  if(Head == Tail) Empty = true;
  pSpaces->Signal();
}
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
template<class T, unsigned NumBuffers>
inline bool TCMtQueue<T, NumBuffers>::IsEmpty()
{
  return Empty;
}

#endif //#ifndef TRC_MTQUEUE_H
